{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Set
  ( d_C_empty
  , d_C_fromList
  , nd_C_fromList
  , d_C_null
  , nd_C_null
  , d_C_insert
  , nd_C_insert
  , d_C_delete
  , nd_C_delete
  , d_C_deleteAll
  , nd_C_deleteAll
  , d_C_size
  , nd_C_size
  , d_C_member
  , nd_C_member
  , d_C_difference
  , nd_C_difference
  , d_C_toList
  , nd_C_toList
  , d_C_union
  , nd_C_union )
  where

import Basics
import qualified Data.Curry_Map
import qualified Curry_Prelude


d_C_empty :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
d_C_empty cd cs = Data.Curry_Map.d_C_empty cd cs

d_C_fromList :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Data.Curry_Map.C_Map t0
  Curry_Prelude.OP_Unit
d_C_fromList x1 x2 cd cs = Data.Curry_Map.d_C_fromList x1 (Curry_Prelude.d_C_map
  d_OP_fromList_dot_uscore_hash_lambda1 x2 cd cs) cd cs

nd_C_fromList :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
nd_C_fromList x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Data.Curry_Map.nd_C_fromList x1 (Curry_Prelude.nd_C_map
  (wrapDX id d_OP_fromList_dot_uscore_hash_lambda1) x2 s0 cd cs) s1 cd cs))

d_OP_fromList_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  Curry_Prelude.OP_Unit
d_OP_fromList_dot_uscore_hash_lambda1 x1 cd cs = Curry_Prelude.OP_Tuple2 x1
  Curry_Prelude.OP_Unit

d_C_null :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_null cd cs = Data.Curry_Map.d_C_null

nd_C_null :: IDSupply -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Func (Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit)
  Curry_Prelude.C_Bool
nd_C_null s cd cs = wrapDX id Data.Curry_Map.d_C_null

d_C_insert :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> t0
  -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
d_C_insert x1 x2 x3 cd cs = Data.Curry_Map.d_C_insert x1 x2
  Curry_Prelude.OP_Unit x3 cd cs

nd_C_insert :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> t0
  -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> IDSupply -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
nd_C_insert x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Data.Curry_Map.nd_C_insert x1 x2 Curry_Prelude.OP_Unit x3 s0 cd cs

d_C_delete :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> t0
  -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
d_C_delete x1 x2 x3 cd cs = Data.Curry_Map.d_C_delete x1 x2 x3 cd cs

nd_C_delete :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> t0
  -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> IDSupply -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
nd_C_delete x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Data.Curry_Map.nd_C_delete x1 x2 x3 s0 cd cs

d_C_deleteAll :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
d_C_deleteAll x1 x2 x3 cd cs = Data.Curry_Map.d_C_deleteAll x1 x2 x3 cd cs

nd_C_deleteAll :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Data.Curry_Map.C_Map t0
  Curry_Prelude.OP_Unit
nd_C_deleteAll x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Data.Curry_Map.nd_C_deleteAll x1 x2 x3 s0 cd cs

d_C_size :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_size cd cs = Data.Curry_Map.d_C_size

nd_C_size :: IDSupply -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Func (Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit)
  Curry_Prelude.C_Int
nd_C_size s cd cs = wrapDX id Data.Curry_Map.d_C_size

d_C_member :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Data.Curry_Map.C_Map t0
  Curry_Prelude.OP_Unit -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_member x1 cd cs = acceptCs id (Data.Curry_Map.d_C_member x1)

nd_C_member :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> IDSupply
  -> Cover -> ConstStore -> Func t0 (Func (Data.Curry_Map.C_Map t0
  Curry_Prelude.OP_Unit) Curry_Prelude.C_Bool)
nd_C_member x1 s cd cs = wrapDX (wrapNX id) (acceptCs id
  (Data.Curry_Map.nd_C_member x1))

d_C_difference :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
d_C_difference x1 cd cs = acceptCs id (Data.Curry_Map.d_C_difference x1)

nd_C_difference :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> IDSupply
  -> Cover -> ConstStore -> Func (Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit)
  (Func (Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit) (Data.Curry_Map.C_Map t0
  Curry_Prelude.OP_Unit))
nd_C_difference x1 s cd cs = wrapDX (wrapNX id) (acceptCs id
  (Data.Curry_Map.nd_C_difference x1))

d_C_toList :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_toList cd cs = Data.Curry_Map.d_C_keys

nd_C_toList :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func (Data.Curry_Map.C_Map t0
  Curry_Prelude.OP_Unit) (Curry_Prelude.OP_List t0)
nd_C_toList s cd cs = wrapDX id Data.Curry_Map.d_C_keys

d_C_union :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit
d_C_union x1 cd cs = acceptCs id (Data.Curry_Map.d_C_union x1)

nd_C_union :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> IDSupply -> Cover -> ConstStore
  -> Func (Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit) (Func
  (Data.Curry_Map.C_Map t0 Curry_Prelude.OP_Unit) (Data.Curry_Map.C_Map t0
  Curry_Prelude.OP_Unit))
nd_C_union x1 s cd cs = wrapDX (wrapNX id) (acceptCs id
  (Data.Curry_Map.nd_C_union x1))

